.686
.model flat,stdcall
;option casemap:case sensitive 

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
;includelib c:\masm32\lib\kernel32.lib
;includelib \masm32\lib\user32.lib

include struct.inc
include memory.inc


.data?
EndText		dd	?
SuffFrom	dd	?
FullNode	dd	?
FullDepth	dd	?
LayText		dd	?
TreeRoot	dd	?

.code


; >>ebx
AddNode proc
		call	NewNode
		mov		ebx,eax
		mov		eax,[TreeRoot]
		mov		[ebx+node_st.suff],eax
		push	ecx
		push	edi
		lea		edi,[ebx+node_st.links]
		xor		eax,eax
		mov		ecx,HASH_SIZE+1
		rep		stosd
		pop		edi
		pop		ecx
		ret
AddNode endp


; ebx< node
; esi< start
; eax< end
; >> eax
AddLink proc
		push	eax
		call	NewLink
		mov		[eax+link_st.first],esi
		pop		dword ptr [eax+link_st.last]
		push	dword ptr [ebx+node_st.links]
		pop		dword ptr[eax+link_st.next]
		mov		[ebx+node_st.links],eax
		push	ebx
		push	ecx
		xor		ecx,ecx
		mov		[eax+link_st.node],ecx
		mov		[eax+link_st.p1],ecx
		mov		[eax+link_st.p2],ecx
		mov		cl,[esi]
		and		cl,HASH_SIZE-1
		lea		ebx,[ebx+ecx*4+node_st.table]
@@1:	mov		ecx,[ebx]
		jecxz	@@2
		mov		ebx,[ecx+link_st.first]
		movzx	ebx,byte ptr [ebx]
		cmp		[esi],bl
		mov		bl,bh
		adc		ebx,ebx
		lea		ebx,[ebx*4+ecx+link_st.p1]
		jmp		@@1
@@2:	mov		[ebx],eax
		pop		ecx
		pop		ebx
		ret
AddLink endp

; esi < text
; ecx < depth
; ebx < node
; edx - link
; edi - first
Lay proc
		push	esi							;text
		add		esi,ecx
@@0:	mov		al,byte ptr [esi]
		mov		edx,HASH_SIZE-1
		and		edx,eax
		mov		edx,[ebx+edx*4+node_st.table]
		jmp		@@2
@@1:	mov		edi,[edx+link_st.first]
		cmp		al,[edi]
		jz		@@4
		mov		edi,0
		adc		edi,edi
		mov		edx,[edx+edi*4+link_st.p1]
@@2:	test	edx,edx
		jnz		@@1
		pop		eax
		mov		[FullNode],ebx
		mov		[LayText],eax
		neg		eax
		add		eax,esi
		mov		[FullDepth],eax
		xor		eax,eax
		call	AddLink
		mov		ecx,[SuffFrom]
		jecxz	@@3
		mov		[ecx+node_st.suff],ebx
		xor		ecx,ecx
		mov		[SuffFrom],ecx
@@3:	clc
		ret
@@4:	
		mov		eax,[EndText]
		dec		eax
		sub		eax,esi		
		mov		ecx,[edx+link_st.last]
;		jecxz	@@5
		sub		ecx,edi
		cmp		ecx,eax		 
		cmovc	eax,ecx
@@5:	add		edi,eax		
		add		esi,eax		
		cmp		edi,[edx+link_st.last]	
		cmovz	ebx,[edx+link_st.node]
		jz		@@0
		mov		al,[esi]
		cmp		al,[edi]
		jnz		@@7
		pop		eax
		mov		ecx,[SuffFrom]
		jecxz	@@6
		mov		[ecx+node_st.suff],ebx
		mov		[SuffFrom],ebx
@@6:	stc
		ret
@@7:	call	AddNode	; ebx>node
		mov		eax,[edx+link_st.last]
		push	esi
		mov		esi,edi
		call	AddLink			
		mov		esi,[edx+link_st.node]
		mov		[eax+link_st.node],esi
		pop		esi
		xor		eax,eax
		call	AddLink
;		xor		ecx,ecx
;		mov		[eax+link_st.node],ecx
		pop		eax					
		mov		[LayText],eax
		neg		eax
		add		eax,esi
		mov		[FullDepth],eax
		mov		[FullNode],ebx
		mov		ecx,[SuffFrom]
		jecxz	@@8
		mov		[ecx+node_st.suff],ebx
@@8:	mov		[SuffFrom],ebx
		mov		[edx+link_st.last],edi
		mov		[edx+link_st.node],ebx
		clc
		ret
Lay endp





; esi < text
;; ebx - node
;; edx - link
;; edi - frist
Find proc pattern:dword
		mov		esi,[pattern]
		push	esi
		mov		ebx,[TreeRoot]
@@1:	lodsb
		test	al,al
		jz		@@ret
		mov		edx,[ebx+node_st.links]
		jmp		@@3
@@2:	mov		edi,[edx+link_st.first]
		scasb
		jz		@@5
		mov		edx,[edx+link_st.next]
@@3:	test	edx,edx
		jnz		@@2
@@err:		pop	eax
		xor		eax,eax
		ret
@@4:	lodsb
		test	al,al
		jz		@@ret
		scasb
		jnz		@@err
@@5:	cmp		edi,[edx+link_st.last]
		jnz		@@4
		mov		ebx,[edx+link_st.node]
		jmp		@@1
@@ret:	pop		eax
		neg		eax
		add		eax,esi
		dec		eax
		neg		eax
		add		eax,edi
		ret
Find endp



MakeTree proc text:dword
		push		esi		;    VC  
		mov		eax,[text]
		mov		[LayText],eax
		inc		eax
		mov		[EndText],eax
		call	AddNode
		mov		[TreeRoot],ebx
		mov		[FullNode],ebx
		mov		[ebx+node_st.suff],ebx
		mov		esi,[LayText]
		xor		eax,eax
		mov		[FullDepth],eax
		call	AddLink
		jmp		@@4
@@1:	mov		[EndText],esi
		xor		eax,eax
		mov		[SuffFrom],eax
		mov		ebx,[FullNode]
		mov		ecx,[FullDepth]
		mov		esi,[LayText]
		jmp		@@3
@@2:	mov		eax,-1
		add		eax,ecx
		cmovc	ecx,eax
		mov		ebx,[ebx+node_st.suff]
		push	ebx
		push	ecx
		push	esi
		call	Lay
		pop		esi
		pop		ecx
		pop		ebx	
		jc		@@4
@@3:	inc		esi
		cmp		esi,[EndText]
		jc		@@2
@@4:	mov		esi,[EndText]
		lodsb
		test	al,al
		jnz		@@1
		pop		esi
		mov		eax,[TreeRoot]
		ret
MakeTree endp

ClearTree proc
	jmp ClearMemory
ClearTree endp


	end


